macroScript Auto_Frame_Face category:"Sheephao Tools" buttontext:"Auto Frame Face" tooltip:"Auto Frame Face" Icon:#("Sheephao_Tools",1)
(
	local pot1  --Line start point
	local pot2  --Line end point
	local potM  --The middle of the line
	local pot3  --Extrude value point
	local Dist  --Extrude value
	local offset_value  --Offset value
	local extrude_boolean --Extrude or not(boolean)
	local extrude_type --Extrude type
	local specify_extrude_value -- Specify extrude value
	local ini_file = ((getDir #plugcfg) + "\\Sheephao_Tools.ini")
	
	--read ini setting
	extrude_boolean=getIniSetting ini_file "AutoFrameFace" "Extrude_Boolean"
	if extrude_boolean=="" then 
		(	
			setinisetting ini_file "AutoFrameFace" "Extrude_Boolean" "True"
			extrude_boolean="True"
		)
	extrude_type=getinisetting ini_file "AutoFrameFace" "Extrude_Type"
	if extrude_type=="" then 
		(
			setinisetting ini_file "AutoFrameFace" "Extrude_Type" "Viewport"
			extrude_type="Viewport"
		)
	offset_value=getIniSetting ini_file "AutoFrameFace" "Offset_Value"
	if offset_value=="" then 
		(
			setinisetting ini_file "AutoFrameFace" "Offset_Value" "40"
			offset_value="40"
		)
	specify_extrude_value=getIniSetting ini_file "AutoFrameFace" "Specify_Extrude_Value"
	if specify_extrude_value=="" then 
		(
			setinisetting ini_file "AutoFrameFace" "Specify_Extrude_Value" "0"
			specify_extrude_value="0"
		)

	fn CreatFace =
	(
		pot1=pickpoint snap:#3d
		if pot1==#escape or pot1==#rightClick then return ok
		pot2=pickpoint snap:#3d rubberband:pot1
		if pot2==#escape or pot2==#rightClick then return ok
		
		case of 
			(
				(extrude_boolean=="True" and extrude_type=="Viewport"):
					(
						pot3=pickpoint snap:#3d rubberband:pot2
						if pot3==#escape or pot3==#rightClick then return ok
						dist=distance pot2 pot3
					)
				(extrude_boolean=="True" and extrude_type=="Specify"):dist=(specify_extrude_value as float)
				(extrude_boolean=="False"):dist=0
			)
		
		--Create new line
		potM=(pot1+pot2)/2
		newline = splineShape pos:potM isSelected:on
		addnewspline newline
		addknot newline 1 #corner  #curve pot1
		addknot newline 1 #corner  #curve pot2
		updateshape newline
		
		--Set offset
		offset_value=(offset_value as float)
		if valoffset!=0 then 
			(
				local p1
				local p2
				local p3
				local p4
				local mat1
				local Llength
				
				p1=getKnotPoint $ 1 1
				p2=getKnotPoint $ 1 2
				Llength=distance p1 p2
				p3=p2-p1
				mat1=rotateZMatrix -90
				p4=p3*mat1*(offset_value/Llength)
				move $ p4
			)
		
		--Set Etrude
		if dist!=0 then
			(
				modPanel.addModToSelection (Extrude ()) ui:on
				$.modifiers[#Extrude].amount = dist
			)
	)
	CreatFace()
)
