--Poly Auto Mapper
--Sheephao
--2004.9

macroScript Poly_Auto_Mapper category:"Sheep Poly Tools" buttontext:"Զͼ" tooltip:"PolyԶͼָ" Icon:#("Sheep_Poly_Tools",1)
(
	local length_u,length_v
	local tile_u,tile_v
	local map_channel
	
	fn main_operation map_type =
	(
		local sel_faces_ary=#()
		local unmapped_faces_ary=#()
		local map_verts_ary=#()
		local face_normal
		local face_center
		
		sel_faces_ary=(polyop.getfaceselection $) as array
		if sel_faces_ary.count==0 then return ok
		u=length_u/tile_u
		v=length_v/tile_v
		case map_type of
		(
			"single":
			(
				for face in sel_faces_ary do
				(
					
					face_normal=polyop.getfacenormal $ face
					face_center=polyop.getfacecenter $ face
					z=face_normal
					rot_m=rotateZMatrix 90
					x=z*rot_m
					x.z=0
					x=normalize x
					y=cross x z 
					m1=(matrix3 x y z face_center)
					subobjectLevel = 4
					polyop.setfaceselection $ face					
					modPanel.addModToSelection (Uvwmap ()) ui:off
					objTM=$.transform
					modTM=getModContextTM $ $.modifiers[#UVW_Mapping]
					m=m1*modTM*(inverse objTM)
					m=(matrix3 m.row1 m.row2 m.row3 [0,0,0])
					$.modifiers[#UVW_Mapping].length=length_u
					$.modifiers[#UVW_Mapping].width =length_v
					$.modifiers[#UVW_Mapping].mapChannel = map_channel
					$.modifiers[#UVW_Mapping].utile = tile_u
					$.modifiers[#UVW_Mapping].vtile = tile_v
					$.modifiers[#UVW_Mapping].gizmo.transform=m
					modPanel.setCurrentObject $.modifiers[#UVW_Mapping]
					--maxOps.CollapseNodeTo $ 1 on
					maxOps.CollapseNode $ on
				)--end for
			)
			"whole":
			(	
				face_normal=[0,0,0]
				face_center=[0,0,0]
				for face in sel_faces_ary do
				(
					face_normal=face_normal+(polyop.getfacenormal $ face)
					face_center=face_center+(polyop.getfacecenter $ face)
				)--end for
				face_center=face_center/sel_faces_ary.count
				z=normalize face_normal
				rot_m=rotateZMatrix 90
				x=z*rot_m
				x.z=0
				x=normalize x
				y=cross x z
				m1=(matrix3 x y z face_center)
				subobjectLevel = 4
				modPanel.addModToSelection (Uvwmap ()) ui:off
				objTM=$.transform
				modTM=getModContextTM $ $.modifiers[#UVW_Mapping]
				m=m1*modTM*(inverse objTM)
				$.modifiers[#UVW_Mapping].length=length_u
				$.modifiers[#UVW_Mapping].width =length_v
				$.modifiers[#UVW_Mapping].mapChannel = map_channel
				$.modifiers[#UVW_Mapping].utile = tile_u
				$.modifiers[#UVW_Mapping].vtile = tile_v
				$.modifiers[#UVW_Mapping].gizmo.transform=m
				modPanel.setCurrentObject $.modifiers[#UVW_Mapping]
				--maxOps.CollapseNodeTo $ 1 on
				--maxOps.CollapseNode $ on
			)
		)--end case
	)--end function
	
	rollout frmmain "Polyͼָ" width:144 height:176
	(
		spinner spn_l "Length:" pos:[16,32] width:120 height:16 enabled:true range:[-1e+009,1e+009,100] scale:10
		spinner spn_w "Width:" pos:[24,56] width:112 height:16 range:[-1e+009,1e+009,100] scale:10
		spinner spn_u_t "U Tile:" pos:[32,80] width:104 height:16 range:[-1e+009,1e+009,1] scale:0.1
		spinner spn_v_t "V Tile:" pos:[32,104] width:104 height:16 range:[-1e+009,1e+009,1] scale:0.1
		spinner spn_map_channel "Map Channel:" pos:[24,128] width:112 height:16 range:[1,99,1] type:#integer scale:1
		button btn_single_assign "ָ" pos:[8,152] width:64 height:16
		button btn_whole_assign "ָ" pos:[72,152] width:64 height:16
		button btn_default "Ĭֵ" pos:[8,8] width:64 height:16
		button btn_set_default "趨Ĭֵ" pos:[72,8] width:64 height:16
	
		local ini_file = ((getDir #plugcfg) + "\\Sheephao_Tools.ini")
		
		on frmmain open do
		(
			length_u=getinisetting ini_file "PolyAutoMapper" "Length"
			if length_u=="" then setinisetting ini_file "PolyAutoMapper" "Length" "100" else spn_l.value=(length_u as float)
			length_v=getinisetting ini_file "PolyAutoMapper" "Width"
			if length_v=="" then setinisetting ini_file "PolyAutoMapper" "Width" "100" else spn_w.value=(length_v as float)
			tile_u=getinisetting ini_file "PolyAutoMapper" "UTile"
			if tile_u=="" then setinisetting ini_file "PolyAutoMapper" "UTile" "1" else spn_u_t.value=(tile_u as float)
			tile_v=getinisetting ini_file "PolyAutoMapper" "VTile"
			if tile_v=="" then setinisetting ini_file "PolyAutoMapper" "VTile" "1" else spn_v_t.value=(tile_v as float)
			map_channel=getinisetting ini_file "PolyAutoMapper" "MapChannel"
			if map_channel=="" then setinisetting ini_file "PolyAutoMapper" "MapChannel" "1" else spn_map_channel.value=(map_channel as integer)
		)--end do
		on btn_single_assign pressed do
		(
			if (classof $)==Editable_Poly then
			(	
				length_u=spn_l.value
				length_v=spn_w.value
				tile_u=spn_u_t.value
				tile_v=spn_v_t.value
				map_channel=spn_map_channel.value
				main_operation "single"
			)	
		)--end do
		on btn_whole_assign pressed do
		(
			if (classof $)==Editable_Poly then
			(	
				length_u=spn_l.value
				length_v=spn_w.value
				tile_u=spn_u_t.value
				tile_v=spn_v_t.value
				map_channel=spn_map_channel.value
				main_operation "whole"
			)
		)--end do
		on btn_set_default pressed  do
		(
			setinisetting ini_file "PolyAutoMapper" "Length" (spn_l.value as string)
			setinisetting ini_file "PolyAutoMapper" "Width" (spn_w.value as string)
			setinisetting ini_file "PolyAutoMapper" "UTile" (spn_u_t.value as string)
			setinisetting ini_file "PolyAutoMapper" "VTile" (spn_v_t.value as string)
			setinisetting ini_file "PolyAutoMapper" "MapChannel" (spn_map_channel.value as string)
		)--end do
		on btn_default pressed  do
		(
			length_u=getinisetting ini_file "PolyAutoMapper" "Length"
			if length_u=="" then setinisetting ini_file "PolyAutoMapper" "Length" "100" else spn_l.value=(length_u as float)
			length_v=getinisetting ini_file "PolyAutoMapper" "Width"
			if length_v=="" then setinisetting ini_file "PolyAutoMapper" "Width" "100" else spn_w.value=(length_v as float)
			tile_u=getinisetting ini_file "PolyAutoMapper" "UTile"
			if tile_u=="" then setinisetting ini_file "PolyAutoMapper" "UTile" "1" else spn_u_t.value=(tile_u as float)
			tile_v=getinisetting ini_file "PolyAutoMapper" "VTile"
			if tile_v=="" then setinisetting ini_file "PolyAutoMapper" "VTile" "1" else spn_v_t.value=(tile_v as float)
			map_channel=getinisetting ini_file "PolyAutoMapper" "MapChannel"
			if map_channel=="" then setinisetting ini_file "PolyAutoMapper" "MapChannel" "1" else spn_map_channel.value=(map_channel as integer)
		)--end do
	)	
	
	
	createdialog frmmain pos:[32,70] style:#(#style_titlebar, #style_border, #style_sysmenu,#style_minimizebox)
)