--Poly Perron Creator
--Sheephao
--2004.9
macroScript Poly_Auto_Perron category:"Sheep Poly Tools" buttontext:"̨" tooltip:"Poly̨" Icon:#("Sheep_Poly_Tools",3)
(
	include "Sheephao_Functions_Array_Arithmetic.ms"
	
	local pot1	--stair point 1
	local pot2	--stair point 2
	local pot3	--stair point 3
	local pot4	--stair point 4
	local step_amount	--amount of steps
	local v1	--unit vector from pot1 to pot4
	local v2	--unit vector from pot2 to pot3
	local step_height1,step_height2	--height of step
	local perron	--node of perron
	local sel_faces_ary=#()
	local del_faces_ary=#()
	local current_verts_ary=#()
	
	fn CreatePerron=
	(	
		sel_faces_ary=polyop.getfaceselection $
		if sel_faces_ary.numberset==0 then
		(
			print "No face selected."
			return ok
		)--end if
		for e in sel_faces_ary do
		(	
			current_verts_ary=(polyop.getvertsusingface $ e) as array
			if current_verts_ary.count==4 then
			(
				pot1=polyop.getvert $ current_verts_ary[1]
				temp_edges=(polyop.getedgesusingvert $ current_verts_ary[1]) as array
				temp_verts=(polyop.getvertsusingedge $ temp_edges) as array
				pot3=arys current_verts_ary temp_verts
				temp_verts=#(current_verts_ary[1],pot3[1])
				pot3=polyop.getvert $ pot3[1]
				current_verts_ary=arys current_verts_ary temp_verts
				pot2=polyop.getvert $ current_verts_ary[1]
				pot4=polyop.getvert $ current_verts_ary[2]
				if abs(pot2.z-pot1.z)>abs(pot4.z-pot1.z) then
				(
					p=pot2
					pot2=pot4
					pot4=p
				)--end if
				
				step_amount1=abs(pot1.z-pot4.z)/150
				step_amount2=abs(pot3.z-pot2.z)/150
				if (step_amount1-floor(step_amount1))>=0.5 then (step_amount1=ceil step_amount1) else (step_amount1=floor step_amount1)
				if (step_amount2-floor(step_amount2))>=0.5 then (step_amount2=ceil step_amount2) else (step_amount2=floor step_amount2)
				if step_amount1<step_amount2 then step_amount=step_amount1 else step_amount=step_amount2
				print step_amount
				if step_amount>=2 then
				(
					step_height1=(pot4.z-pot1.z)/step_amount
					step_height2=(pot3.z-pot2.z)/step_amount
					
					v1=(pot4-pot1)/(step_amount-1)
					v1.z=0
					v2=(pot3-pot2)/(step_amount-1)
					v2.z=0
					
					p1=copy pot1
					p2=copy pot2
									
					p3=p2+[0,0,step_height2]
					p4=p1+[0,0,step_height1]
					new_faces_ary=#()
					pi1=polyop.createvert $ p1
					pi2=polyop.createvert $ p2
					pi3=polyop.createvert $ p3
					pi4=polyop.createvert $ p4
					append new_faces_ary (polyop.createpolygon $ #(pi1,pi2,pi3,pi4))
					for i in 2 to step_amount do
					(
						p4=p4+v1
						p3=p3+v2
						pi1=pi4
						pi2=pi3
						pi3=polyop.createvert $ p3
						pi4=polyop.createvert $ p4
						append new_faces_ary (polyop.createpolygon $ #(pi1,pi2,pi3,pi4))
						p3=p3+([0,0,step_height2] as point3)
						p4=p4+([0,0,step_height1] as point3)
						pi1=pi4
						pi2=pi3
						pi3=polyop.createvert $ p3
						pi4=polyop.createvert $ p4
						append new_faces_ary (polyop.createpolygon $ #(pi1,pi2,pi3,pi4))
					)--end for
					normal_check=polyop.getfacenormal $ new_faces_ary[2]
					if normal_check.z<0 then polyOp.flipNormals $ new_faces_ary
					append del_faces_ary e
				)--end if
			)--end if
		)--end for
		polyop.deleteFaces $ del_faces_ary
		update $
	)--end function
	
	if classof $ ==Editable_Poly then CreatePerron()
)