--Scene Materials Browser
--Beta 1.0
--Sheephao
--2004.2
macroScript Scene_materials_Browser category:"Sheephao Tools" buttontext:"Scene Materials Browser" tooltip:"Scene Materials Browser Beta 1.0" Icon:#("Sheephao_Tools",6)
(
--Scene_Materials_Browser=newrolloutfloater "Scene Materials Browser Beta 1.0" 600 640

rollout frmmain "" width:592 height:608
(
	ActiveXControl mat_list_box "{BDD1F04B-858B-11D1-B16A-00C0F0283628}" pos:[8,8] width:576 height:440
	GroupBox grp1 "ʲ" pos:[8,520] width:576 height:80
	checkbox chk_2sided "2-Sided" pos:[160,536] width:72 height:16
	colorPicker cp_diffuse "Diffuse color:" pos:[16,536] width:136 height:16 color:(color 150 150 150)
	spinner spn_s_i_amount "Self-Illumination amount:" pos:[334,536] width:130 height:16 type:#integer scale:1
	spinner spn_opacity "Opacity:" pos:[49,556] width:64 height:16 range:[0,100,0] type:#integer scale:1
	colorPicker cp_s_i_color "Self-Illumination color:" pos:[256,556] width:208 height:16 color:(color 0 0 0)
	checkbox chk_use_s_i_color "Use Self-Illumination color" pos:[256,576] width:208 height:16
	checkbox chk_super_sample "Super sampler" pos:[120,556] width:112 height:16
	dropdownList ddl_sample_type "" pos:[16,576] width:216 height:22 items:#("Adaptive Halton", "Adaptive Uniform", "Hammersley", "Max 2.5 Star", "Unknow") selection:4
	button btnUpdate "" pos:[8,456] width:88 height:16 toolTip:"Update list from scene materials"
	button btn_select_all "ѡ" pos:[152,456] width:96 height:16
	button btn_select_invert "ѡ" pos:[256,456] width:96 height:16
	button btn_select_none "ȫѡ" pos:[360,456] width:96 height:16
	button btn_unselect_subs "ȡѡӲ" pos:[464,456] width:96 height:16
	button btn_put_all "ȫʵ༭" pos:[8,480] width:160 height:16 toolTip:"Put scene materials to the Material Editor"
	button btn_put_selected "ѡʵ༭" pos:[176,480] width:160 height:16 toolTip:"Put selected scene materials to the Material Editor"
	button btn_creat_selectionset "ѡĲʽѡ" pos:[8,504] width:192 height:16 toolTip:"Creat a Selection Set from selected materials"
	button btn_clear_buffer "޸Ļ" pos:[480,544] width:96 height:16 toolTip:"Clear all changes before apply"
	button btn_apply_change "Ӧ޸" pos:[480,576] width:96 height:16 toolTip:"Apply all changes and clear the buffer"
	--button btn_language_switch "C" pos:[568,456] width:16 height:16
	button btn_apply_current "Ӧõǰ" pos:[480,560] width:96 height:16 toolTip:"Apply current parameters to selected materials"
	checkbox chk_warning "" pos:[480,528] width:88 height:16 checked:true
	checkbox chk_invert "ת˳" pos:[512,480] width:72 height:16
	button btn_clear_editor "ñ༭ΪĬ״̬" pos:[344,480] width:160 height:16 toolTip:"Set Material Editor to default"
	
	struct modify_table (two_sided,diffuse_color,opacity,si_amount,si_color,use_si_color,enable_sampler,sampler_type)

	local lis --listitems of mat_list_box
	local classid_array=#()
	local classname_array=#()
	local c_mat
	local mat_array=#() --All scene materials array
	local sel_mat_array=#() --Selected materials array
	local mod_table
	local list_col_index_check --List box column header click index check buffer
	local msg_array=#()
	
	fn mat_type_name mat_classid=
	(	
		classid_string=(mat_classid[1] as string)+","+(mat_classid[2] as string)
		class_index=finditem classid_array classid_string
		if class_index!=0 then return classname_array[class_index] else return "Unknow"
	)
	
	fn listsubitem_value shader_name:"" two_sided:"" diffuse:"" opacity:"" si_amount:"" si_color:"" use_si_color:"" sampler_enable:"" sampler_type:""=
	(
		local li
		local lisub
		
		li=lis[lis.count]
		lisub=li.listsubitems
		lisub.add text:shader_name
		lisub.add text:two_sided
		lisub.add text:diffuse
		lisub.add text:opacity
		lisub.add text:si_amount
		lisub.add text:si_color
		lisub.add text:use_si_color
		lisub.add text:sampler_enable
		case classof sampler_type of
		(
			integer:
			(
				case sampler_type of
				(
					(0):lisub.add text:"Adaptive Halton"
					(1):lisub.add text:"Adaptive Uniform"
					(2):lisub.add text:"Hammersley"
					(3):lisub.add text:"Max 2.5 Star"
					default:lisub.add text:"Unknow"
				)
			)
			string:lisub.add text:sampler_type
		)
	)
	
	fn mat_list_value current_mat parent_mat=
	(	
		local li
		local lisub
		local mat_type
		
		append mat_array current_mat
		key_string="m"+((lis.count+1) as string)
		li=lis.add (lis.count+1) key_string current_mat.name
		lisub=li.listsubitems
		mat_type=mat_type_name (current_mat.classid)
		lisub.add text:mat_type
		lisub.add text:parent_mat
		case mat_type of
		(
			"Standardmaterial":
			(
				listsubitem_value 	shader_name:current_mat.shaderbyname \
									two_sided:(current_mat.twosided as string) \
									diffuse:(current_mat.diffuse as string) \
									opacity:current_mat.opacity \
									si_amount:current_mat.selfIllumAmount \
									si_color:(current_mat.SelfIllumColor as string) \
									use_si_color:(current_mat.useSelfIllumColor as string) \
									sampler_enable:(current_mat.samplerEnable as string) \
									sampler_type:current_mat.sampler
			)
			"Advanced_Lighting_Override":
			(
				mat_list_value current_mat.basematerial current_mat.name
			)
			"Architectural":
			(
				listsubitem_value 	shader_name:current_mat.template \
									two_sided:(current_mat.twosided as string) \
									diffuse:(current_mat.diffuse as string) \
									si_amount:current_mat.luminance \
									sampler_enable:(current_mat.samplerEnable as string) \
									sampler_type:current_mat.samplerbyname
			)
			"Blend":
			(
				mat_list_value current_mat.map1 current_mat.name
				mat_list_value current_mat.map2 current_mat.name
			)
			"compositematerial":
			(
				for element in current_mat.materiallist do
				(
					if element!=null then mat_list_value element current_mat.name
				)
			)
			"DoubleSided":
			(
				mat_list_value current_mat.material1 current_mat.name
				mat_list_value current_mat.material2 current_mat.name
			)
			"InkNPaint":
			(
				listsubitem_value 	two_sided:(current_mat.two_side_on as string) \
									diffuse:(current_mat.paint_color as string) \
									sampler_enable:(current_mat.samplerEnable as string) \
									sampler_type:current_mat.sampler
			)
			"Lightscape_Mtl":
			(
				mat_list_value current_mat.basematerial current_mat.name
			)
			"MorpherMaterial":
			(
				c_mat=current_mat
				if current_mat.base!=null then mat_list_value current_mat.base current_mat.name
				for i in 1 to 100 do
				(
					temp_str="if tool1.c_mat.Mat_" + (i as string) + "!=null then tool1.mat_list_value tool1.c_mat.Mat_" + (i as string )+ " tool1.c_mat.name"
					execute temp_str
				)
			)
			"Multimaterial":
			(
				for element in current_mat.materialList do mat_list_value element current_mat.name
			)
			"RaytraceMaterial":
			(
				listsubitem_value 	shader_name:current_mat.shaderbyname \
									two_sided:(current_mat.twosided as string) \
									diffuse:(current_mat.diffuse as string) \
									si_amount:current_mat.Self_Illum_Amount \
									si_color:(current_mat.Luminosity as string) \
									use_si_color:(current_mat.Luminosity_Color_On as string)
			)
			"Shell_Material":
			(
				mat_list_value current_mat.originalMaterial current_mat.name
				mat_list_value current_mat.bakedMaterial current_mat.name
			)
			"Shellac":
			(
				mat_list_value current_mat.shellacMtl1 current_mat.name
				mat_list_value current_mat.shellacMtl2 current_mat.name
			)
			"TopBottom":
			(
				mat_list_value current_mat.topMaterial current_mat.name
				mat_list_value current_mat.bottomMaterial current_mat.name
			)
			"DGS_Material__physics_phen":
			(
				listsubitem_value 	diffuse:(current_mat.diffuse as string)
			)
		)
		if parent_mat!="" then
		(
			li.forecolor=color 255 0 0
			for element in li.listsubitems do element.forecolor=color 255 0 0
		)
	)
	
	fn mat_list_update=
	(
		lis.clear()
		mat_array=#()
		for element in scenematerials do
		(
			mat_list_value element ""
		)
	)
	
	fn apply_change_update_list current_mat=
	(
		local mat_key_array=#()
		local temp_array=for e in mat_array collect e
		k=finditem temp_array current_mat
		while k!=0 do
		(
			append mat_key_array ("m"+(k as string))
			temp_array[k]=""
			k=finditem temp_array current_mat
		)
		for mat_key in mat_key_array do
		(
			if mod_table.two_sided!="unchanged" and lis[mat_key].listsubitems!=undefined and lis[mat_key].listsubitems[4].text!="" then lis[mat_key].listsubitems[4].text=mod_table.two_sided as string
			if mod_table.diffuse_color!="unchanged" and lis[mat_key].listsubitems!=undefined and lis[mat_key].listsubitems[5].text!="" then lis[mat_key].listsubitems[5].text=mod_table.diffuse_color as string
			if mod_table.opacity!="unchanged" and lis[mat_key].listsubitems!=undefined and lis[mat_key].listsubitems[6].text!="" then lis[mat_key].listsubitems[6].text=mod_table.opacity as string
			if mod_table.si_amount!="unchanged" and lis[mat_key].listsubitems!=undefined and lis[mat_key].listsubitems[7].text!="" then lis[mat_key].listsubitems[7].text=mod_table.si_amount as string
			if mod_table.si_color!="unchanged" and lis[mat_key].listsubitems!=undefined and lis[mat_key].listsubitems[8].text!="" then lis[mat_key].listsubitems[8].text=mod_table.si_color as string
			if mod_table.use_si_color!="unchanged" and lis[mat_key].listsubitems!=undefined and lis[mat_key].listsubitems[9].text!="" then lis[mat_key].listsubitems[9].text=mod_table.use_si_color as string
			if mod_table.enable_sampler!="unchanged" and lis[mat_key].listsubitems!=undefined and lis[mat_key].listsubitems[10].text!="" then lis[mat_key].listsubitems[10].text=mod_table.enable_sampler as string
			if mod_table.sampler_type!="unchanged" and lis[mat_key].listsubitems!=undefined and lis[mat_key].listsubitems[11].text!="" then lis[mat_key].listsubitems[11].text=mod_table.sampler_type as string
		)
	)
	
	fn apply_change current_mat=
	(
		case (current_mat.classid as string) of
		(
			"#(2, 0)":--Standard
			(
				if mod_table.two_sided!="unchanged" then current_mat.twosided=mod_table.two_sided

				if mod_table.diffuse_color!="unchanged" then current_mat.diffuse=mod_table.diffuse_color
				if mod_table.opacity!="unchanged" then current_mat.opacity=mod_table.opacity
				if mod_table.si_amount!="unchanged" then current_mat.selfIllumAmount=mod_table.si_amount
				if mod_table.si_color!="unchanged" then current_mat.selfIllumcolor=mod_table.si_color
				if mod_table.use_si_color!="unchanged" then current_mat.useSelfIllumColor=mod_table.use_si_color
				if mod_table.enable_sampler!="unchanged" then current_mat.samplerEnable=mod_table.enable_sampler
				if mod_table.sampler_type!="unchanged" then current_mat.samplerbyname=mod_table.sampler_type
				apply_change_update_list current_mat
			)
			"#(689195325, 1828668151)":--Advanced_Lighting_Override
			(
				apply_change current_mat.basematerial
			)
			"#(332471230, 1763586103)":--Architectural
			(
				if mod_table.two_sided!="unchanged" then current_mat.twosided=mod_table.two_sided
				if mod_table.diffuse_color!="unchanged" then current_mat.diffuse=mod_table.diffuse_color
				if mod_table.si_amount!="unchanged" then current_mat.luminance=mod_table.si_amount
				if mod_table.enable_sampler!="unchanged" then current_mat.samplerEnable=mod_table.enable_sampler
				if mod_table.sampler_type!="unchanged" then current_mat.samplerbyname=mod_table.sampler_type
				apply_change_update_list current_mat
			)
			"#(592, 0)":--Blend
			(
				apply_change current_mat.map1
				apply_change current_mat.map2
			)
			"#(1641811159, 325323510)":--Composite
			(
				for element in current_mat.materiallist do
				(
					if element!=null then apply_change element
				)
			)
			"#(528, 0)":--Double Sided
			(
				apply_change current_mat.material1
				apply_change current_mat.material2
			)
			"#(27793050, 1295605925)":--Ink n Paint
			(
				if mod_table.two_sided!="unchanged" then current_mat.two_side_on=mod_table.two_sided
				if mod_table.diffuse_color!="unchanged" then current_mat.paint_color=mod_table.diffuse_color
				if mod_table.enable_sampler!="unchanged" then current_mat.samplerEnable=mod_table.enable_sampler
				if mod_table.sampler_type!="unchanged" then current_mat.samplerbyname=mod_table.sampler_type
				apply_change_update_list current_mat
			)
			"#(1167726318, 664240028)":--Lightscapt
			(
				apply_change current_mat.basematerial
			)
			"#(1268332512, 974929316)":--Morpher
			(
				c_mat=current_mat
				if current_mat.base!=null then apply_change current_mat.base
				for i in 1 to 100 do

				(
					temp_str="if tool1.c_mat.Mat_" + (i as string) + "!=null then tool1.apply_change tool1.c_mat.Mat_" + (i as string )
					execute temp_str
				)
			)
			"#(512, 0)":--Multi/Sub-Object
			(
				for element in current_mat.materialList do apply_change element
			)
			"#(655953908, 849023086)":--Raytrace
			(
				if mod_table.two_sided!="unchanged" then current_mat.twosided=mod_table.two_sided
				if mod_table.diffuse_color!="unchanged" then current_mat.diffuse=mod_table.diffuse_color
				if mod_table.si_amount!="unchanged" then current_mat.Self_Illum_Amount=mod_table.si_amount
				if mod_table.si_color!="unchanged" then current_mat.Luminosity=mod_table.si_color
				if mod_table.use_si_color!="unchanged" then current_mat.Luminosity_Color_On=mod_table.use_si_color
				apply_change_update_list current_mat
			)
			"#(597, 0)":--Shell Material
			(
				apply_change current_mat.originalMaterial
				apply_change current_mat.bakedMaterial
			)
			"#(1190024042, 0)":--Shellac
			(
				apply_change current_mat.shellacMtl1
				apply_change current_mat.shellacMtl2
			)
			"#(256, 0)":--Top/Buttom
			(
				apply_change current_mat.topMaterial
				apply_change current_mat.bottomMaterial
			)
			"#(2004030991, 2030068573)":--DGS_Material_physics_phen
			(
				if mod_table.diffuse_color!="unchanged" then current_mat.diffuse=mod_table.diffuse_color
				apply_change_update_list current_mat
			)
		)
	)

	on frmmain open do
	(	
		lis=mat_list_box.listitems
		mod_table=modify_table two_sided:"unchanged" diffuse_color:"unchanged" opacity:"unchanged" si_amount:"unchanged" si_color:"unchanged" use_si_color:"unchanged" enable_sampler:"unchanged" sampler_type:"unchanged"
		
		mat_list_box.gridlines=true
		mat_list_box.MultiSelect=true
		mat_list_box.allowcolumnreorder=true
		mat_list_box.view=#lvwreport
		mat_list_box.checkboxes=true
		mat_list_box.FullRowSelect=true
		chs = mat_list_box.columnHeaders
		chs.add text:"Name"
		chs.add text:"Type"
		chs.add text:"Parent Material"
		chs.add text:"Shader type"
		chs.add text:"2-Side"
		chs.add text:"Diffuse Color(RGB)"
		chs.add text:"Opacity"
		chs.add text:"S-I Amount"
		chs.add text:"S-I Color(RGB)"
		chs.add text:"Use S-I Color"
		chs.add text:"Super Sampler"
		chs.add text:"SS Type"
		list_col_index_check=0
		
		st=stringstream ""
		showclass "*:material" to:st
		seek st 0
		while not (eof st) do
		(
			temp_string_array=filterstring (readline st) ",:{ }"
			append classname_array temp_string_array[1]
			temp_id=((("0x"+temp_string_array[3]) as integer)as string)+","+((("0x"+temp_string_array[4]) as integer)as string)
			append classid_array temp_id
		)
		
		msg_array=#("It's more than 24 materials (exclude sub-materials) in current scene.\nPut the first 24 materials (exclude sub-materials) into Material Editor?", \
					"It's more than 24 materials (include sub-materials) in current selection.\nPut the first 24 materials (include sub-materials) into Material Editor?", \
					"It's cannot be undone,are you sure?")
	)
	on mat_list_box itemCheck Item do
	(
		checked_key=for element in lis where element.selected==true collect element.key
		if item.selected==false or checked_key.count<2 then
		(
			checked_key=item.key
			case item.checked of
			(
				true:
				(
					checked_index=(replace checked_key 1 1 "") as integer
					append sel_mat_array mat_array[checked_index]
				)
				false:
				(
					checked_index=(replace checked_key 1 1 "") as integer
					del_number=finditem sel_mat_array mat_array[checked_index]
	
					deleteItem sel_mat_array del_number
				)
			)
		)
		else
		(
			checked_index=for element in checked_key collect ((replace element 1 1 "") as integer)
			case item.checked of
			(
				true:
				(
					for element in checked_index do
					(
						if finditem sel_mat_array mat_array[element]==0 then append sel_mat_array mat_array[element]
					)
					for element in checked_key do
					(
						lis[element].checked=true
					)
				)
				false:
				(
					for element in checked_index do
					(
						del_number=finditem sel_mat_array mat_array[element]
						if del_number!=0 then deleteItem sel_mat_array del_number
					)
					for element in checked_key do
					(
						lis[element].checked=false
					)
				)
			)
		)
	)
	on mat_list_box itemClick Item do
	(	
		--2-sided
		if item.listsubitems[4]!=undefined and item.listsubitems[4].text!="" then
		(
			case item.listsubitems[4].text of
			(
				"true":
				(
					chk_2sided.checked=true
				)
				"false":
				(
					chk_2sided.checked=false
	
				)
			)
		)
		else chk_2sided.checked=false
		--diffuse
		if item.listsubitems[5]!=undefined and item.listsubitems[5].text!="" then
		(
			color_str=filterstring item.listsubitems[5].text "(color )"
			cp_diffuse.color=color (color_str[1] as float) (color_str[2] as float) (color_str[3] as float)
		)
		else cp_diffuse.color=color 0 0 0
		--opacity
		if item.listsubitems[6]!=undefined and item.listsubitems[6].text!="" then spn_opacity.value=(item.listsubitems[6].text as integer) else spn_opacity.value=0
		--S-I amount
		if item.listsubitems[7]!=undefined and item.listsubitems[7].text!="" then spn_s_i_amount.value=(item.listsubitems[7].text as integer) else spn_s_i_amount.value=0
		--S-I color
		if item.listsubitems[8]!=undefined and item.listsubitems[8].text!="" then
		(
			color_str=filterstring item.listsubitems[8].text "(color )"
			cp_s_i_color.color=color (color_str[1] as float) (color_str[2] as float) (color_str[3] as float)
		)
		else cp_s_i_color.color=color 0 0 0
		--Use S-I color
		if item.listsubitems[9]!=undefined and item.listsubitems[9].text!="" then
		(
			case item.listsubitems[9].text of
			(
				"true":
				(
					chk_use_s_i_color.checked=true
				)
				"false":
				(
					chk_use_s_i_color.checked=false
				)
			)
		)
		else chk_use_s_i_color.checked=false
		--Enable super sampler
		if item.listsubitems[10]!=undefined and item.listsubitems[10].text!="" then
		(
			case item.listsubitems[10].text of
			(
				"true":
				(
					chk_super_sample.checked=true
				)
				"false":
				(
					chk_super_sample.checked=false
				)
			)
		)
		else chk_super_sample.checked=false
		--Sampler type
		if item.listsubitems[11]!=undefined and item.listsubitems[11].text!="" then
		(
			sample_number=finditem ddl_sample_type.items item.listsubitems[11].text
			ddl_sample_type.selection=sample_number
		)
		else ddl_sample_type.selection=5
	)
	on mat_list_box columnClick ColumnHeader do
	(
		mat_list_box.Sorted=true
		if list_col_index_check==ColumnHeader.index then
		(
			if mat_list_box.SortOrder==#lvwAscending then mat_list_box.SortOrder=#lvwDescending else mat_list_box.SortOrder=#lvwAscending
		)
		else
		(
			mat_list_box.SortOrder=#lvwAscending
			list_col_index_check=ColumnHeader.index
		)
		mat_list_box.SortKey=columnheader.index-1
	)
	on chk_2sided changed state do
		mod_table.two_sided=chk_2sided.checked
	on cp_diffuse changed col do
		mod_table.diffuse_color=cp_diffuse.color
	on spn_s_i_amount changed val do
		mod_table.si_amount=spn_s_i_amount.value
	on spn_opacity changed val do
		mod_table.opacity=spn_opacity.value
	on cp_s_i_color changed col do
		mod_table.si_color=cp_s_i_color.color
	on chk_use_s_i_color changed state do
		mod_table.use_si_color=chk_use_s_i_color.checked
	on chk_super_sample changed state do
		mod_table.enable_sampler=chk_super_sample.checked
	on ddl_sample_type selected sel do
	(
		if ddl_sample_type.selection!=5 then mod_table.sampler_type=ddl_sample_type.items[ddl_sample_type.selection]
	)
	on btnUpdate pressed do
	(
		mat_list_box.Sorted=false
		sel_mat_array=#()
		mat_list_update()
	)
	on btn_select_all pressed do
	(
		for element in mat_list_box.listitems do element.checked=true
		sel_mat_array=#()
		sel_mat_array=for element in mat_array collect element
	)
	on btn_select_invert pressed do
	(
		for element in lis do element.checked=not element.checked
		sel_mat_array=#()
		for i in 1 to lis.count do
		(
			if lis[i].checked==true then
			(
				m_index=(replace lis[i].key 1 1 "") as integer
				append sel_mat_array mat_array[m_index]
			)
		)
	)
	on btn_select_none pressed do
	(
		for element in mat_list_box.listitems do element.checked=false
		sel_mat_array=#()
	)
	on btn_unselect_subs pressed do
	(
		for element in lis do
		(
			if element.listsubitems[2]!=null and element.listsubitems[2].text!="" then element.checked=false
		)
		sel_mat_array=#()
		for i in 1 to lis.count do
		(
			if lis[i].checked==true then
			(
				m_index=(replace lis[i].key 1 1 "") as integer
				append sel_mat_array mat_array[m_index]
			)
		)
	)
	on btn_put_all pressed do
	(	
		print chk_invert.checked
		if scenematerials.count>24 then
		(
			put_check=querybox msg_array[1] title:"Scene Materials Browser"
			if put_check==true then 
			(
				case chk_invert.checked of
				(
					false:(for i in 1 to 24 do setmeditmaterial i scenematerials[i])
					true:(for i in 1 to 24 do setmeditmaterial (25-i) scenematerials[i])
				)
			)
		)
		else 
		(
			case chk_invert.checked of
			(
				false:(for i in 1 to scenematerials.count do setmeditmaterial i scenematerials[i])
				true:(for i in 1 to scenematerials.count do setmeditmaterial (25-i) scenematerials[i])
			)
		)
	)
	on btn_put_selected pressed do
	(
		if sel_mat_array.count>24 then
		(
			put_check=querybox msg_array[2] title:"Scene Materials Browser"
			if put_check==true then for i in 1 to 24 do setmeditmaterial i sel_mat_array[i]
			if put_check==true then 
			(
				case chk_invert.checked of
				(
					false:(for i in 1 to 24 do setmeditmaterial i sel_mat_array[i])
					true:(for i in 1 to 24 do setmeditmaterial (25-i) sel_mat_array[i])
				)
			)
		)
		else
		(
			case chk_invert.checked of
			(
				false:(for i in 1 to sel_mat_array.count do setmeditmaterial i sel_mat_array[i])
				true:(for i in 1 to sel_mat_array.count do setmeditmaterial (25-i) sel_mat_array[i])
			)
		)
	)
	on btn_creat_selectionset pressed do
	(
		if sel_mat_array.count!=0 then
		(
			local sets_name="Material_Selection_Set_1"
			local i=1
			try s=selectionSets[sets_name]
			catch s=undefined
			while s!=undefined do
			(
				i+=1
				sets_name="Material_Selection_Set_" + (i as string)
				try s=selectionSets[sets_name]
				catch s=undefined
			)
			local obj_array=($geometry/* as array)+($shapes/* as array)
			local sel_obj_array=#()
			for element in obj_array do
			(
				if finditem sel_mat_array element.material!=0 then append sel_obj_array element
			)
			if sel_obj_array.count!=0 then selectionsets[sets_name]=sel_obj_array
		)
	)
	on btn_clear_buffer pressed do
	(
		mod_table.two_sided="unchanged"
		mod_table.diffuse_color="unchanged"
		mod_table.opacity="unchanged"
		mod_table.si_amount="unchanged"
		mod_table.si_color="unchanged"
		mod_table.use_si_color="unchanged"
		mod_table.enable_sampler="unchanged"
		mod_table.sampler_type="unchanged"
	)
	on btn_apply_change pressed do
	(
		if (mod_table.two_sided!="unchanged" \
		or mod_table.diffuse_color!="unchanged" \
		or mod_table.opacity!="unchanged" \
		or mod_table.si_amount!="unchanged" \
		or mod_table.si_color!="unchanged" \
		or mod_table.use_si_color!="unchanged" \
		or mod_table.enable_sampler!="unchanged" \
		or mod_table.sampler_type!="unchanged") \
		and sel_mat_array.count!=0 then
		(	
			apply_check=chk_warning.checked
			if apply_check==true then 
			(	
				apply_check=querybox msg_array[3] title:"Scene Materials Browser"
			)
			else apply_check=true
			if apply_check==true then
			(
				mat_list_check_array=#()
				for element in lis do
				(
					if element.checked==true then append mat_list_check_array element.key
				)
				for element in sel_mat_array do
				(
					apply_change element
				)
				for element in lis do
				(
					if (finditem mat_list_check_array element.key)!=0 then
					(
						element.checked=true
					)
				)
				mod_table.two_sided="unchanged"
				mod_table.diffuse_color="unchanged"
				mod_table.opacity="unchanged"
				mod_table.si_amount="unchanged"
				mod_table.si_color="unchanged"
				mod_table.use_si_color="unchanged"
				mod_table.enable_sampler="unchanged"
				mod_table.sampler_type="unchanged"
			)
		)
	
	)

	on btn_apply_current pressed do
	(
		if sel_mat_array.count!=0 then
		(	
			apply_check=chk_warning.checked
			if apply_check==true then 
			(	
				apply_check=querybox msg_array[3] title:"Scene Materials Browser"
			)
			else apply_check=true
			if apply_check==true then
			(
				mod_table.two_sided=chk_2sided.checked
				mod_table.diffuse_color=cp_diffuse.color
				mod_table.si_amount=spn_s_i_amount.value
				mod_table.si_color=cp_s_i_color.color
				mod_table.use_si_color=chk_use_s_i_color.checked
				mod_table.enable_sampler=chk_super_sample.checked
				if ddl_sample_type.selection!=5 then mod_table.sampler_type=ddl_sample_type.items[ddl_sample_type.selection] else mod_table.sampler_type="unchanged"
				
				mat_list_check_array=#()
				for element in lis do
				(
					if element.checked==true then append mat_list_check_array element.key
				)
				for element in sel_mat_array do
				(	
					apply_change element
				)
				for element in lis do
				(
					if (finditem mat_list_check_array element.key)!=0 then
					(
						element.checked=true
					)
				)
				mod_table.two_sided="unchanged"
				mod_table.diffuse_color="unchanged"
				mod_table.si_amount="unchanged"
				mod_table.si_color="unchanged"
				mod_table.use_si_color="unchanged"
				mod_table.enable_sampler="unchanged"
				mod_table.sampler_type="unchanged"
			)
		)
	)
	on btn_clear_editor pressed  do
	(
		for i in 1 to 24 do meditmaterials[i]=standard name:((i as string)+" - Default")
	)
)
	createdialog frmmain pos:[32,70] style:#(#style_titlebar, #style_border, #style_sysmenu,#style_minimizebox)
)