(
	global lTasks_4648134686 =
	#(
		(struct s( tName = "Notetracks",
			
			bChecked = true,
			
			fn count =
			(
				try (numNoteTracks TrackViewNodes.Max_MotionClip_Manager) catch ("-")
			),
			
			fn clean =
			(
				try while (numNoteTracks TrackViewNodes.Max_MotionClip_Manager > 0) do
				(
					local n = getNoteTrack TrackViewNodes.Max_MotionClip_Manager 1
					deleteNoteTrack TrackViewNodes.Max_MotionClip_Manager n
				)
				catch()
			)
			
		);)(),
		
		(struct s( tName = "Reactor Collisions",
			
			bChecked = true,
			
			fn count =
			(
				if reactor != undefined then reactor.getNumStoredCollisions()
			),
			
			fn clean =
			(
				if reactor != undefined then reactor.clearStoredCollisions()
			)
			
		);)(),
		
		(struct s( tName = "Empty Layers",
			
			bChecked = false,
			
			fn count =
			(
				local nEmptyLayers = 0
				
				for nLayer = layerManager.count to 2 by -1 do
				(
					local layer = layerManager.getLayer (nLayer - 1)
					
					local lNodes = undefined
					layer.nodes &lNodes
					
					if lNodes.count == 0 do nEmptyLayers += 1
				)
				
				return nEmptyLayers
			),
			
			fn clean =
			(
				-- active layer = layer 0
				(layerManager.getLayer 0).current = true
				
				for nLayer = layerManager.count to 2 by -1 do
				(
					local layer = layerManager.getLayer (nLayer - 1)
					
					local lNodes = undefined
					layer.nodes &lNodes
					
					if lNodes.count == 0 do layerManager.deleteLayerByName layer.name
				)
			)
			
		);)(),
		
		(struct s( tName = "Materialeditor",
			
			bChecked = false,
			
			fn count =
			(
				"-"
			),
			
			fn clean =
			(
				for n = 1 to meditmaterials.count do
				(
					local tMat = "mat"+ (scenematerials.count + n) as string
					
					if matchpattern (renderers.current as string) pattern:"v_ray*"
						then meditmaterials[n] = vraymtl name:tMat
						else meditmaterials[n] = standardmaterial name:tMat
				)
			)
			
		);)()
	)
	
	local tCode = ""
	tCode += "rollout cRollout \"\" ("
		
		-- add tasks
		for nTask = 1 to lTasks_4648134686.count do
		(
			local task = lTasks_4648134686[nTask]
			local tTask = nTask as string
			
			-- button
			tCode += "button cBut"+ tTask +" \""+ task.tName +"\" width:140 height:24 pos:[5,"+ ((nTask-1)*28+5) as string +"];"
			tCode += "on cBut"+ tTask +" pressed do ("
			tCode += "lTasks_4648134686["+ tTask +"].clean();"
			tCode += "cRollout.cLab"+ tTask +".text = lTasks_4648134686["+ tTask +"].count() as string;"
			tCode += ");"
			
			-- counter
			tCode += "label cLab"+ tTask +" \"-\" pos:[190,"+ ((nTask-1)*28+9) as string +"];"
			
			-- checkbox
			tCode += "checkbox cChk"+ tTask +" checked:"+ task.bChecked as string +" pos:[240,"+ ((nTask-1)*28+9) as string +"];"
		)
		
		-- on rollout open
		tCode += "on cRollout open do ("
		for nTask = 1 to lTasks_4648134686.count do
		(
			local tTask = nTask as string
			tCode += "cLab"+ tTask +".text = lTasks_4648134686["+ tTask +"].count() as string;"
		)
		tCode += ");"
		
		-- clean all selected
		tCode += "button cButAllSel \"Clean all selected\" width:255 height:24 pos:[5,"+ (lTasks_4648134686.count*28+5+10) as string +"];"
		tCode += "on cButAllSel pressed do ("
		tCode += "for cChk in cRollout.controls where classof cChk == CheckBoxControl and cChk.checked do ("
		tCode += "local nTask = (substring cChk.name 5 (cChk.name.count)) as number;"
		tCode += "lTasks_4648134686[nTask].clean();"
		tCode += "))"
		
	tCode += ")"
	local cRollout = execute tCode
	createDialog cRollout 265 (5+lTasks_4648134686.count*28+40)
)